<?php

namespace QUI\NodeDev;

use QUI;
use QUI\Exception;
use QUI\Smarty\Collector;

use function json_encode;

class Events
{
    /**
     * Beginnt das Sammeln von Template-Daten und fügt die importmap hinzu.
     *
     * @throws Exception
     */
    public static function onTemplateBegin(
        Collector $Collection,
        QUI\Template $Template
    ): void {
        $nodePath = Console::getNodeProjectPath();
        $generator = new ImportMapGenerator($nodePath);
        $importMap = $generator->generateImportMap();

        $importMapString = PHP_EOL;
        $importMapString .= '<script type="importmap">' . PHP_EOL;
        $importMapString .= json_encode($importMap, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES) . PHP_EOL;
        $importMapString .= '</script>';
        $importMapString .= '<script>';
        $importMapString .= "window.process = { env: { NODE_ENV: 'production' } };";
        $importMapString .= '</script>';

        $Collection->append($importMapString);
    }

    public static function onHtaccessGenerate(&$htaccessContent): void
    {
        $htaccessContent .= PHP_EOL;
        $htaccessContent .= '<IfModule mod_rewrite.c>' . PHP_EOL;
        $htaccessContent .= '   RewriteEngine On' . PHP_EOL;
        $htaccessContent .= '   RewriteRule ^node_modules/(.*)$ /var/package/quiqqer/node-development/bin/nodejs/node_modules/$1 [L]' . PHP_EOL;
        $htaccessContent .= '</IfModule>' . PHP_EOL;
        $htaccessContent .= PHP_EOL;
    }
}
